//+------------------------------------------------------------------+
//|                                                Multi_Williams.mq4 |
//|                                          Copyright  2010,Brooky |
//|                                                           Brooky |
//+------------------------------------------------------------------+
/* 
NOTE: The Signals are generic only and need to be changed by YOU to suit your style.
Go to the bottom of the code marked //----SIgnals--+ and line up variables as you see fit.
If you cannot code, just define the crosses you want to see in the forum and I am sure
one of us coders can help, but please give it a go, you might surprise yourself.
*/
#property copyright "Copyright  2010,Brooky"
#property link      "Brooky"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Orange
#property indicator_color4 Blue
#property indicator_color5 Crimson


#property indicator_width1 3
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 2
#property indicator_width5 2


#property indicator_minimum -100
#property indicator_maximum 0

#property indicator_level1 -20
#property indicator_level2 -40
#property indicator_level3 -50
#property indicator_level4 -60
#property indicator_level5 -80

//---- input parameters
extern int        WPR_Period = 2000;//Longest M1 WPR- Others are divided into this.
extern int       WPR_Smooth = 8;//Smooth WPR out
extern int       trendMa=55;//how many bars back should the M1 tail have been significantly less or more than head.
extern int       short_level=-60;//williams level to go short from
extern int       long_level=-40;//williams level to go long from
extern int       bars_to_show = 5000;//Cut back on processing time
extern bool      sigs_on = false;//turn arrows on. CHANGE SIGNAL CODE TO SUIT YOURSELF.
//---- buffers
double arraytf1[];//M1
double arraytf2[];//m15
double arraytf3[];//H1
double Arrow1[];
double Arrow2[];


double maOnArraytf1[];
double maOnArraytf2[];
double maOnArraytf3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(8);
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,maOnArraytf1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,maOnArraytf2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,maOnArraytf3); 
     
   SetIndexStyle(3,DRAW_ARROW);//long
   SetIndexArrow(3,233);
   SetIndexBuffer(3,Arrow1);
   SetIndexEmptyValue(3,0.0);
   
   SetIndexStyle(4,DRAW_ARROW);//short
   SetIndexArrow(4,234);
   SetIndexBuffer(4,Arrow2);
   SetIndexEmptyValue(4,0.0);
   
   SetIndexBuffer(5,arraytf1);
    
   SetIndexBuffer(6,arraytf2);
    
   SetIndexBuffer(7,arraytf3);
    SetIndexLabel(7,"H1");


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   //--------Get the arrays ready for data and backward read---+

   //M1  
   ArrayResize(arraytf1, bars_to_show);
   ArraySetAsSeries(arraytf1, true);
   //M15
   ArrayResize(arraytf2, bars_to_show);
   ArraySetAsSeries(arraytf2, true);
   //H1
   ArrayResize(arraytf3, bars_to_show);
   ArraySetAsSeries(arraytf3, true);

   for( int i = bars_to_show-1; i >= 0; i--){
          
      arraytf1[i] = iWPR(NULL,1,WPR_Period,i);//M1
         SetIndexLabel(5,"M1");
      
         int m15period = NormalizeDouble(WPR_Period/15,0);
      arraytf2[i] = iWPR(NULL,15,m15period,i);//M15
         SetIndexLabel(6,"M15");
      
         int h1period = NormalizeDouble(WPR_Period/60,0);
      arraytf3[i] = iWPR(NULL,60,h1period,i);//H1
         SetIndexLabel(7,"H1");
     
      
   }
   for( i = bars_to_show-1-WPR_Period; i >= 0; i--) 
   {    

    maOnArraytf1[i] = iMAOnArray(arraytf1, 0,WPR_Smooth, 0, 0, i);//M1
    maOnArraytf2[i] = iMAOnArray(arraytf2, 0,WPR_Smooth, 0, 0, i);//M15
    maOnArraytf3[i] = iMAOnArray(arraytf3, 0,WPR_Smooth, 0, 0, i);//H1
    
   //------------------------------Signals------------+
   if(sigs_on !=false)
   {
   int tf1X_dn=0,tf1X_up =0,tf1_dn =0,tf1_up =0,tf2_dn =0,tf2_up =0,tf3_dn =0,tf3_up =0,trma_up =0,trma_dn =0;
   
   //Validate M1 cross 
   if( maOnArraytf1[i]<short_level && maOnArraytf1[i+1]>=short_level)tf1X_dn =1;
   if( maOnArraytf1[i]>long_level&& maOnArraytf1[i+1]<=long_level)tf1X_up =1;
   
   //M1 direction
   if( maOnArraytf1[i]< maOnArraytf1[i+1])tf1_dn =1;
   if( maOnArraytf1[i]> maOnArraytf1[i+1])tf1_up =1;   
   
   
   //M5 direction
   if( maOnArraytf2[i]< maOnArraytf2[i+1])tf2_dn =1;
   if( maOnArraytf2[i]> maOnArraytf2[i+1])tf2_up =1;  
   
   //H1 direction
   if( maOnArraytf3[i]< maOnArraytf3[i+1])tf3_dn =1;
   if( maOnArraytf3[i]> maOnArraytf3[i+1])tf3_up =1; 
   
   //Trend Ma if you want to go with the trend or countertrend.
   double trendMa_now =  iMA(NULL,0,trendMa,0,MODE_SMMA,PRICE_CLOSE,i);  
   double trendMa_b4 =  iMA(NULL,0,trendMa,0,MODE_SMMA,PRICE_CLOSE,i+1);
   
   if(trendMa_now<trendMa_b4)trma_dn =1;
   if(trendMa_now>trendMa_b4)trma_up =1;
   
   //Trigger the arrows
   if(tf1_dn ==1 && tf2_dn ==1 && tf3_dn ==1 && trma_dn ==1)
   {
   Arrow2[i]=maOnArraytf1[i];//Short
   }
   else Arrow2[i]=0.0;
   
   if(tf1_up ==1 && tf2_up ==1 && tf3_up ==1 && trma_up ==1)
   {
   Arrow1[i]=maOnArraytf1[i];//Long
   }
   else Arrow1[i]=0.0;
   }
    
   }
   return(0);
  }
//+------------------------------------------------------------------+